classification
Title: _curses issues on 64-bit big-endian (e.g, AIX)
Type: behavior Stage:
Components: Library (Lib) Versions: Python 2.6, Python 2.5
process
Status: closed Resolution: accepted
Dependencies: Superseder:
Assigned To: akuchling Nosy List: akuchling, lukemewburn
Priority: normal Keywords: patch

Created on 2007-09-06 03:32 by lukemewburn, last changed 2008-01-09 12:30 by akuchling. This issue is now closed.

Files
File name Uploaded Description Edit
curses-attr_t-long.diff lukemewburn, 2007-09-06 03:32
Messages (3)
msg55675 - (view) Author: Luke Mewburn (lukemewburn) Date: 2007-09-06 03:32
Attempting to use curses attributes with python 2.3.5 on AIX (64bit
powerpc) doesn't work, and occasionally results in exceptions being raised.

_cursesmodule.c assumes that attr_t is a `long' and uses the "l"
decoding of PyArg_ParseTuple() to read values from python to C.  On
platforms where sizeof(int) == sizeof(long), this isn't a problem. 
However, on LP64, especially big-endian LP64, this results in the wrong
value being stored in the target address.

My solution is to use ParseTuple("l") into a variable with an explicit
type of 'long', and then assign that to the attr_t variable that the
underlying curses(3) functions are called with.

(I don't know if there's a different convention for dealing with reading
numbers from python into underlying C types where the C type size isn't
consistently an `int' or a `long', other that reading into an explicit
int/long and then assigning/casting to the final type)

The code in question doesn't appear to have changed much between python
2.3.5 and the svn trunk (as at 20070906), and my patch for the former
applied fairly cleanly to my checkout of the latter.  I've attached a
diff from the svn checkout.
msg59539 - (view) Author: A.M. Kuchling (akuchling) * (Python committer) Date: 2008-01-08 14:59
Applied to trunk in rev. 59854, and to 25-maint in rev. 59855.

Thanks for your bugfix!
msg59589 - (view) Author: A.M. Kuchling (akuchling) * (Python committer) Date: 2008-01-09 12:30
Rev. 59870 on trunk fixes another usage of &attr in the wrapper for the
chgat() method.

Luke, a 2.5.2 release is not too far off.  If possible, can you please
try compiling the 25-maint branch on AIX to check that the problems are
fixed?  Thanks!
History
Date User Action Args
2008-01-09 12:30:16akuchlingsetmessages: + msg59589
2008-01-08 14:59:17akuchlingsetstatus: open -> closed
resolution: accepted
messages: + msg59539
versions: + Python 2.6, Python 2.5, - Python 2.3
2007-09-17 09:17:02jafosetpriority: normal
assignee: akuchling
components: + Library (Lib), - Extension Modules
nosy: + akuchling
2007-09-09 16:54:20loewissetkeywords: + patch
2007-09-06 03:32:34lukemewburncreate